require(['config'], function() {
	require([
		'jquery'
	], function($) {

	});
});

let EASYPAY_PAYMENT_CREATE = '/api/easypay/payment/create'; // 이지페이 결제 생성
let KICC_JAVASCRIPT_URL;
let KICC_ACTION_WEB_URL;
let MALL_ID;

var popPageObj = {
	init: function () {
		this.button();
		this.change();
		this.view();
	},
	parentPopFn: null,
	args: null,
	returnType: null,
	button: function() {
		$('#ITP_BTN_PO_PAYMENT_CLOSE_POP').on('click', function () {
			$('#ITP_BIZPOP_PO_PAYMENT').modal('hide'); // 팝업닫기
		});
		$('#ITP_BTN_PO_PAYMENT_CONFIRM_POP').on('click', function () {
			popPageObj.fnPaymentReq();
		});
	}, 
	change: function() {
	}, 	
	view: function() {
		$('#ITP_FORM_PO_PAYMENT_POPUP_PAY_TP_CD').val(popPageObj.args.payTpCd);
		$('#ITP_FORM_PO_PAYMENT_POPUP_BRAND_ID').val(popPageObj.args.brandId);
		$('#ITP_FORM_PO_PAYMENT_POPUP_STORE_ID').val(popPageObj.args.storeId);
		
		// 결제타입코드 : 10(선불(충전)), 20(후불(결제)), 30(후불(선결제))
		if(popPageObj.args.payTpCd == '10') {  
			$('#ITP_BIZPOP_PO_PAYMENT_PAY_TP_NM').text('선불(충전)');
		} else if(popPageObj.args.payTpCd == '20') {  
			$('#ITP_BIZPOP_PO_PAYMENT_PAY_TP_NM').text('후불(결제)');
			$('#ITP_FORM_PO_PAYMENT_POPUP_STTL_MGNT_UNQ_NO').val(popPageObj.args.sttlMgntUnqNo); // 정산관리고유번호
			$('#ITP_FORM_PO_PAYMENT_POPUP_GOODS_AMT').val(popPageObj.args.goodsAmt); // 결제금액
			$('#ITP_FORM_PO_PAYMENT_POPUP_GOODS_AMT').attr('readonly','readonly');			
		} else if(popPageObj.args.payTpCd == '30') {  
			$('#ITP_BIZPOP_PO_PAYMENT_PAY_TP_NM').text('후불(선결제)');
		}			
		// 이지페이 결제 생성
		let param = $('#ITP_FORM_PO_PAYMENT_POPUP').serializeObject();	
		param.goodsAmt = $('#ITP_FORM_PO_PAYMENT_POPUP_GOODS_AMT').val() == '' ? 0 : $('#ITP_FORM_PO_PAYMENT_POPUP_GOODS_AMT').val();	
		fn_ajax_call(EASYPAY_PAYMENT_CREATE, JSON.stringify(param), function(result) {
			// console.log(JSON.stringify(result));
			$('#ITP_FORM_PO_PAYMENT_POPUP_PO_ORD_NO').val(result.poOrdNo); // 주문번호
			$('#ITP_FORM_PO_PAYMENT_POPUP_ORD_NM').val(result.ordNm); // 구매자명
			$('#ITP_FORM_PO_PAYMENT_POPUP_GOODS_NM').val(result.goodsNm); // 상품명
			$('#ITP_FORM_PO_PAYMENT_POPUP_KICC_JAVASCRIPT_URL').val(result.kicc_javascript_url); // 
			$('#ITP_FORM_PO_PAYMENT_POPUP_KICC_ACTION_WEB_URL').val(result.kicc_action_web_url); // 
			$('#ITP_FORM_PO_PAYMENT_POPUP_MALL_ID').val(result.mallId); // 
			
			$('#ITP_FORM_PO_PAYMENT_POPUP .fnPoOrdNo').text(result.poOrdNo); // 주문번호
			$('#ITP_FORM_PO_PAYMENT_POPUP .fnOrdNm').text(result.ordNm); // 구매자명
			$('#ITP_FORM_PO_PAYMENT_POPUP .fnGoodsNm').text(result.goodsNm); // 상품명
			$('#ITP_FORM_PO_PAYMENT_POPUP_ORD_TEL').val(result.ordTel); // 휴대전화번호
			$('#ITP_FORM_PO_PAYMENT_POPUP_ORD_EMAIL').val(result.ordEmail); // 이메일
			
			KICC_JAVASCRIPT_URL = result.kicc_javascript_url;
            KICC_ACTION_WEB_URL = result.kicc_action_web_url;
			MALL_ID = result.mallId;
			
			console.log('KICC_JAVASCRIPT_URL : ' + KICC_JAVASCRIPT_URL);
            console.log('KICC_ACTION_WEB_URL : ' + KICC_ACTION_WEB_URL);
			console.log('MALL_ID : ' + MALL_ID);
			
		}, 'POST');
	}, 
	fnPaymentReq: function() {
		const formId = '#ITP_FORM_PO_PAYMENT_POPUP';
		itp_fn_form_clear_validate(null, formId);
		
		var vali_goodsAmt = itp_fn_form_validate(formId, formId + '_GOODS_AMT', ['empty'], undefined);
		var vali_ordTel = itp_fn_form_validate(formId, formId + '_ORD_TEL', ['empty'], undefined);
		var vali_ordEmail = itp_fn_form_validate(formId, formId + '_ORD_EMAIL', ['email'], undefined);
		
		if (vali_goodsAmt && vali_ordTel && vali_ordEmail) {		
			// var sttlRjctRsn = $('#ITP_FORM_PO_PAYMENT_POPUP_STTL_RJCT_RSN').val();	
			
			// popPageObj.parentPopFn(sttlRjctRsn);
			// $('#ITP_BIZPOP_PO_PAYMENT').modal('hide'); // 팝업닫기
			
			$(formId).attr('action', '/oqpo-view/easypay/oqpo/oqpo_order.jsp');
			$(formId).submit();
		}
	} 
};

function itp_fn_BIZPOP_PO_PAYMENT(parentPopFn, args, returnType) {
	$('#ITP_BIZPOP_PO_PAYMENT').one('shown.bs.modal', function(e) {
		itp_fn_fire_window_resize();
	}).one('hidden.bs.modal', function(e) {
		$('#ITP_BIZPOP_PO_PAYMENT').remove();
	}).modal('show');

	popPageObj.parentPopFn = parentPopFn;
	popPageObj.args = args;
	popPageObj.returnType = returnType;
	popPageObj.init();
}
