require(['config'], function() {
	require([
	], function($) {
		mobPageObj.init();
	});
});

/*API URL*/
const API_MOBILE_INIT_INFO	= '/api/pomng/init-pchReq';
const API_MOBILE_SAVE		= '/api/pomng/save-pchReq';
const API_POP_SEARCH_LIST	= '/api/whs/mng/pop-whs-search';
const API_POP_ITEM_LIST 	= '/api/item/pop-grid-list';

let mobPageObj = {
	init: function () {
		this.ui.init();
		this.event.init();
		this.ready();
	},
	ui: {
		init: function () {
			this.info();
		},
		info: function() {
			$('input:hidden[id$="_BRAND_ID"]').val(fn_make_user_info.get('brandId'));
			$('input:hidden[id$="_STORE_ID"]').val(fn_make_user_info.get('storeId'));
		}
	},
	event: {
		init: function() {
			this.button();
		},
		button: function() {
			$('button[id^="ITP_BTN_MPOMNG01010_DETAIL"]').on('click', function() {
				if($(this).is('[data-call-popup]')) {
					console.log($(this).attr('id'));
					mobPopObj.show($(this).data('call-popup'));
				} else {
					var id = $(this).attr('id');
					switch (id) {
						case 'ITP_BTN_MPOMNG01010_DETAIL_DELROW': contPopObj.list.delRow(); break;
						case 'ITP_BTN_MPOMNG01010_DETAIL_DELETE_WHS_NM': break;
						case 'ITP_BTN_MPOMNG01010_DETAIL_TEMP_SAVE': break;
						case 'ITP_BTN_MPOMNG01010_DETAIL_CANCEL':break;
					}
				}
				return false;
			});
		}
	},
	ready: function() {
		contPopObj.init();
	}
};

let contPopObj = {
	init: function() {
		this.data.load();
	},
	data: {
		initPchReq: null,
		load: function() {
			var _this = this;
			var callbackFn = function(result) {
				_this.initPchReq = result;
				$('#ITP_FORM_MPOMNG01010_DETAIL #ITP_FORM_MPOMNG01010_DETAIL_BRAND_ID').val(result.brandId);
				$('#ITP_FORM_MPOMNG01010_DETAIL #ITP_FORM_MPOMNG01010_DETAIL_STORE_ID').val(result.storeId);
				$('#ITP_FORM_MPOMNG01010_DETAIL #ITP_FORM_MPOMNG01010_DETAIL_LOAN_DVSN').val(result.loanDvsn);
				$('#ITP_FORM_MPOMNG01010_DETAIL #ITP_FORM_MPOMNG01010_DETAIL_LOAN_MGNT_UNQ_NO').val(result.loanMgntUnqNo);
				$('#ITP_FORM_MPOMNG01010_DETAIL #ITP_FORM_MPOMNG01010_DETAIL_PCH_REQ_DVSN').val(result.pchReqDvsn);

				$('#ITP_FORM_MPOMNG01010_DETAIL .fnOrdUseAmt').text(itp_fn_set_comma(result.ordUseAmt) + '원');
			};
			const key = {brandId:fn_make_user_info.get('brandId'), storeId:fn_make_user_info.get('storeId')};
			fn_ajax_call(API_MOBILE_INIT_INFO, key, callbackFn, 'GET');
		}
	},
	list: {
		rows: [],
		addRow: function() {
		},
		delRow: function() {
			this.detachRow();
		},
		attachRow: function (item) {
			console.log(item);
			var fnIsExist = function(rows) {
				var isExist = false;
				$.each(rows, function(i, row) {
					if(row.brandUnitUnqNo === item.brandUnitUnqNo) {
						isExist = true;
						return false;
					}
				});
				return isExist;
			};
			if(!fnIsExist(this.rows)) {
				this.rows.push(item);
				$('#ITP_LIST_MPOMNG01010_ITEM_AREA .panel-group').append($('#ITP_LIST_MPOMNG01010_DETAIL_ROWCOPY').html());
				var $li = $('#ITP_LIST_MPOMNG01010_ITEM_AREA .panel-group > .row_2:last');
				$li.find('.fnBrandUnitUnqNo').val(item.brandUnitUnqNo);
				$li.find('.fnItemNm').text(item.itemNm);
				$li.find('.fnUnitAmt').text(itp_fn_set_comma(item.unitAmt));
			}
		},
		detachRow: function () {
			$('#ITP_LIST_MPOMNG01010_DETAIL_ROWS li').each(function(index, elem) {
				var isChecked = $(this).find('input[type="checkbox"]').is(':checked');
				console.log(index + " ===> " + isChecked);
			});
		}
	}
};

let mobPopObj = {
	popItem: {
		parentFn: null,
		rows: null,
		init: function(fn) {
			console.log(fn);
			this.parentFn = fn;
			this.search();
		},
		search: function() {
			$('#ITP_LIST_MPOMNG01010_POP_ITEM_AREA .panel-group').empty();
			var callbackFn = function(result) {
				mobPopObj.popItem.rows = result.gridRows;
				$.each(mobPopObj.popItem.rows, function (i, item) {
					$('#ITP_LIST_MPOMNG01010_POP_ITEM_AREA .panel-group').append($('#ITP_LIST_MPOMNG01010_POP_ITEM_ROWCOPY').html());
					var $li = $('#ITP_LIST_MPOMNG01010_POP_ITEM_AREA .panel-group > .row_2:last');
					$li.data('brandUnitUnqNo', item.brandUnitUnqNo);
					$li.data('podrPssblDvsn', item.podrPssblDvsn);
					$li.data('spplyId', item.spplyId);
					$li.data('stddQty', item.stddQty);
					$li.data('storeUnitUnqNo', item.storeUnitUnqNo);
					$li.data('unit', item.unit);
					$li.data('unitAmt', item.unitAmt);
					$li.data('unitGubun', item.unitGubun);
					$li.find('#ITP_FORM_MPOMNG01010_POP_ITEM_CHECKBOX').val(item.itemId);
					$li.find('.fnItemNm').text(item.itemNm);
					$li.find('.fnUnitAmt').text(itp_fn_set_comma(item.unitAmt));
				});
				mobPopObj.popItem.addRow.init();
			};
			let param = $('#ITP_FORM_MPOMNG01010_POPUP_ITEM').serializeObject();
			fn_ajax_call(API_POP_ITEM_LIST, JSON.stringify(param), callbackFn, 'POST');
		},
		addRow: {
			init: function() {
				this.button.init();
			},
			button: {
				init: function() {
					console.log('button');
					var _this = this;
					$('button[id^="ITP_BTN_MPOMNG01010_POP_ITEM_"]').off('click').on('click', function() {
						var id = $(this).attr('id');
						switch (id) {
							case 'ITP_BTN_MPOMNG01010_POP_ITEM_PLUS': _this.actPlus($(this)); break;
							case 'ITP_BTN_MPOMNG01010_POP_ITEM_MINUS': _this.actMinus($(this)); break;
							case 'ITP_BTN_MPOMNG01010_POP_ITEM_ADD': _this.actItemAdd($(this)); break;
							case 'ITP_BTN_MPOMNG01010_POP_ITEM_SEARCH': mobPopObj.popItem.search(); break;
							case 'ITP_BTN_MPOMNG01010_POP_ITEM_CLOSE': mobPopObj.hide(id); break;
						}
						return false;
					});
				},
				actPlus: function(elem) {
					var $div = $(elem).closest('div').find('.num');
					var num = Number($div.text());
					$($div).text((num + 1).toString());
				},
				actMinus: function(elem) {
					var $div = $(elem).closest('div').find('.num');
					var num = Number($div.text());
					if(num <= 1) {
						alert('주문수량을 확인하세요.');
					} else {
						$($div).text((num - 1).toString());
					}
				},
				actItemAdd: function(elem) {
					var index = $(elem).closest('li').index();
					contPopObj.list.attachRow(mobPopObj.popItem.rows[index]);
				}
			}
		},
		delRow: function() {

		}
	},
	popWhsNm: {

	},
	popReqConfirm: {

	},
	show: function(id) {
		console.log('show ===> ' + id);
		$('#' + id).show();
		$('button[id$="CLOSE"]').off('click').on('click', function() {
			var id = $(this).attr('id');
			console.log('CLOSE ===> ' + id);
			if($(this).hasClass('btn-pop-close')) {
				$('#' + id).closest('.mobile-pop-close').hide();
			}
		});
		if(id.indexOf('ITEM_AREA') > -1) {
			this.popItem.init();
		}
	},
	hide: function(id) {
		$('#' + id).closest('.mobile-pop-close').hide();
	}
};
